routes/web.php
<?php

use App\Http\Controllers\AuthCtrl;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\NilaiController;
use App\Http\Controllers\BeasiswaController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\MahasiswaController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::group(["middleware"=>"auth"],function(){
    Route::get('/', [DashboardController::class,'index'])->name("home");
    
    Route::group(["middleware"=>"roleAdmin"],function(){
        Route::resource('mahasiswa',MahasiswaController::class);
        Route::resource('nilai',NilaiController::class);
        Route::resource('users',UserController::class);
        Route::resource('beasiswa',BeasiswaController::class);
        Route::get('beasiswa/{id}/{status}/update',[BeasiswaController::class,'update_status'])->name("update_status");
    });

    Route::group(["middleware"=>"roleMahasiswa"],function(){
        Route::resource('beasiswa',BeasiswaController::class);
    });

    Route::get('logout',[AuthCtrl::class,'logout'])->name("auth.logout");

});

// Route Login
Route::get('login',[AuthCtrl::class,'login'])->name("auth.login");
Route::post('ceklogin',[AuthCtrl::class,'cek_login'])->name("auth.check");

app/Models/Nilai.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Nilai extends Model
{
    use HasFactory;
    public $guarded = ["id"];
}

app/Http/Controllers/NilaiController.php
<?php

namespace App\Http\Controllers;

use Exception;
use App\Models\Nilai;
use App\Models\Mahasiswa;
use Illuminate\Support\Facades\DB;
use App\Http\Requests\StoreNilaiRequest;
use App\Http\Requests\UpdateNilaiRequest;

class NilaiController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    private $title = "Nilai";
    public function index()
    {
        $data = [
            "title" => "Data ".$this->title,
            "dtNilai" => DB::table("nilais")
            ->join("mahasiswas","nilais.nim_mhs","=","mahasiswas.nim_mhs")
            ->select("nilais.*","mahasiswas.nm_mhs")
            ->get()
        ];

        return view("nilai.data",$data);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $data = [
            "title" => "Form ".$this->title,
            "page_name" => "Add ".$this->title,
            "is_edit" => false,
            "dtMhs" => Mahasiswa::where("status_mhs",1)->get()
        ];

        return view("nilai.form",$data);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StoreNilaiRequest $request)
    {        
        try {            
    
            Nilai::create([
                "nim_mhs"=>$request->input("nim_mhs"),
                "semester"=>$request->input("semester"),
                "ipk"=>$request->input("ipk"),
            ]);
   
            // Message
            $mess = [
                "type" => "success",
                "text" => "Data Berhasil Disimpan !"
            ];

            return redirect(route("nilai.index"))->with($mess);

        } catch(Exception $err){
            $mess = [
                "type" => "danger",
                "text" => "Data Gagal Disimpan !<br/>".$err->getMessage()
            ];
            return redirect(route("nilai.index"))->with($mess);
        }
    }

    /**
     * Display the specified resource.
     */
    public function show(Nilai $nilai)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Nilai $nilai)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateNilaiRequest $request, Nilai $nilai)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Nilai $nilai)
    {
        //
    }
}

resources/views/nilai/data.blade.php
@extends('layouts.base')

@section('title',$title)
@section('page_name',$title)

@section("content")
{{-- Notification --}}
@if (session("text"))
    <div class="alert alert-{{ session("type") }} alert-dismissible">
        <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
        {{ session("text") }}
    </div>
@endif
<div class="card">
    <div class="card-header">
        <div class="card-tools">
            <a href="{{ route("nilai.create") }}" class="btn btn-primary btn-xs"><i class="fas fa-plus"></i> ADD NEW</a>
        </div> 
    </div>
    <div class="card-body">
        <table class="data table table-bordered table-striped">
            <thead>
                <tr>
                    <th>NIM</th>
                    <th>NAMA</th>
                    <th>SEMESTER</th>
                    <th>IPK</th>
                    <th>ACTION</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($dtNilai as $rsNilai)                
                    <tr>
                        <td>{{ $rsNilai->nim_mhs}}</td>
                        <td>{{ $rsNilai->nm_mhs}}</td>
                        <td>Semester {{ $rsNilai->semester}}</td>
                        <td>{{ $rsNilai->ipk }}</td>
                        <td class="text-center">
                            <a class="btn btn-warning btn-xs" href="{{ route('mahasiswa.edit',$rsNilai->id) }}"><i class="fas fa-edit"></i></a>
                            <form class="d-inline" action="{{ route("mahasiswa.destroy",$rsNilai->id) }}" method="post">
                                @method("DELETE")
                                <button type="submit" class="btn btn-danger btn-xs"><i class="fas fa-times"></i></button>
                            </form>
                        </td>
                    </tr>
                @endforeach
            </tbody>
        </table>            
    </div>
</div>   
@endsection

resources/views/nilai/form.blade.php
@extends('layouts.base')

@section('title',$title)
@section('page_name',$title)
    
@section('content')
    <div class="row">
        <div class="col-md-7 mx-auto">
          {{-- Notification --}}
            @if ($errors->any())
              <div class="alert alert-danger alert-dismissible">
                <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                <h5><i class="icon fas fa-check"></i> Error</h5>
                Terjadi Kesalahan , silahkan periksa kembali inputan anda
              </div>
            @endif
            <div class="card">
                <div class="card-header">
                    <div class="card-title">
                        {{ $page_name }}
                    </div>
                </div>
                <div class="card-body">
                    <form action="{{ $is_edit ? route("nilai.update",@$rsMhs->id) : route("nilai.store") }}" method="post">
                        @csrf
                        @if ($is_edit)
                          @method("PUT")
                        @endif                                                                      
                        <div class="mb-3">
                          <label for="nim_mhs" class="form-label">NIM</label>
                          <select class="form-control select2" style="width: 100%;" name="nim_mhs" onchange="get_nilai_detail(this,'{{ url('/').'/api/getnilai' }}')">
                              <option value="">- Pilih Mahasiswa -</option>
                              @foreach ($dtMhs as $rsMhs)
                                <option value="{{ $rsMhs->nim_mhs }}">{{ $rsMhs->nim_mhs." | ". $rsMhs->nm_mhs }}</option>
                              @endforeach                            
                          </select>
                        </div>
                        <div class="mb-3 comopt d-none">
                          <label for="semester" class="form-label">Semester</label>
                          <select class="form-control" name="semester" id="semester">
                          </select>
                        </div>
                        <div class="mb-3 comopt d-none">
                          <label for="ipk" class="form-label">IPK</label>
                          <input type="number" name="ipk" id="ipk" class="form-control @error('ipk') is-invalid @enderror" value="{{ @old("ipk")!="" ? @old("ipk") : @$rsNilai->ipk }}" step="0.01">
                          @error("ipk")
                            <div id="valnimmhs" class="invalid-feedback">
                              {{ $message }}
                            </div>
                          @enderror
                        </div>                                        
                        <div class="mb-3 comopt d-none">
                            <input type="submit" value="SIMPAN" class="btn btn-primary btn-md">
                        </div>        
                        <div id="complete"></div>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection